EDBFrame = CreateFrame("Frame", "EDBFrame")
local playername=(UnitName("PLAYER"));

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB_CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB_GuildFrameUpdated() end);
			EDBFrame:UnregisterEvent("ADDON_LOADED");
		end
	elseif(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
		if(prefix==ElgohDatabaseVersion) then
			if(msg=="request sync") then
				if(who~=UnitName("PLAYER")) then
					if(ElgohDebug==1) then Elgoh_Print(who.." requested a sync"); end
					EDB_Sync();
				end
			else
				local name, MS, OS, updated, earned, spent, current=strsplit(":", msg);
				updated=tonumber(updated);
				earned=tonumber(earned);
				spent=tonumber(spent);
				current=tonumber(current);
				if(ELGOHDB[name] and ELGOHDB[name]~=nil) then
					if(ELGOHDB[name]["updated"]<updated) then
						ELGOHDB[name]["MS"]=MS;
						ELGOHDB[name]["OS"]=OS;
						ELGOHDB[name]["updated"]=updated;
						ELGOHDB[name]["earned"]=earned;
						ELGOHDB[name]["spent"]=spent;
						ELGOHDB[name]["current"]=current;
						if(ElgohUpdateNote==1) then Elgoh_Print("Updated "..name); end
					end
				else
					ELGOHDB[name]={}
					ELGOHDB[name]["MS"]=MS;
					ELGOHDB[name]["OS"]=OS;
					ELGOHDB[name]["updated"]=updated;
					ELGOHDB[name]["earned"]=earned;
					ELGOHDB[name]["spent"]=spent;
					ELGOHDB[name]["current"]=current;
					if(ElgohUpdateNote==1) then Elgoh_Print("Added "..name); end
				end
			end
		end
	end
end

-- GL_DKPValues = {
-- ["epgp"] = 1,
-- ["gp_base"] = 0,
-- ["current_dkp_data"] = {

            -- ["Mr Testy"] = {
                -- ["earned"] = 50.00,
                -- ["spent"] = 0.00,
                -- ["current"] = 50.00,  AKA Priority

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function EDB_CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBMSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBMSText:SetHeight(10);
		EDBMSText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBOSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBOSText:SetHeight(10);
		EDBOSText:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		
		EDBDKPText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("RIGHT");
		EDBDKPText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 0, -15);
		EDBDKPText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -15);
		
	end
end

function EDB_GuildFrameUpdated()
	local pname,rank= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if pname == EDB.selected then return end
		if IsShiftKeyDown() then EDB_EDIT(); end
		EDB.selected = pname;
		EDB_UpdateLines(EDB.selected,rank);
	end
end

function EDB_ADD(member,MS,OS)
	ELGOHDB[member]={};
	ELGOHDB[member]["MS"]=MS;
	ELGOHDB[member]["OS"]=OS;
	ELGOHDB[member]["updated"]=time();
end

function EDB_UpdateLines(who,rank)
	if(ElgohIgnoreList[rank]) then EDBFrame:Hide(); return; else EDBFrame:Show(); end
	if(ELGOHDB[who]) then
		EDBMSText:SetText("MS: "..ELGOHDB[who]["MS"]);
		EDBOSText:SetText("OS: "..ELGOHDB[who]["OS"]);
		if(who~=UnitName("PLAYER")) then
			if(ELGOHDB[UnitName("PLAYER")] and ELGOHDB[UnitName("PLAYER")]["current"]~=nil) then
				if(ELGOHDB[who]["current"]) then
					EDBDKPText:SetText("DKP: Yes");
					EDBDKPText:SetTextColor(0.2,1,0.2);
					if((ELGOHDB[playername]["earned"]>ElgohThreshhold and ELGOHDB[who]["earned"]>ElgohThreshhold) or (ELGOHDB[playername]["earned"]<ElgohThreshhold and ELGOHDB[who]["earned"]<ElgohThreshhold)) then
						if(ELGOHDB[who]["current"]>ELGOHDB[playername]["current"]) then
							EDBDKPText:SetText("DKP: No");
							EDBDKPText:SetTextColor(1,0.2,0.2);
						end
					elseif(ELGOHDB[playername]["earned"]<ElgohThreshhold and ELGOHDB[who]["earned"]>ElgohThreshhold) then
						EDBDKPText:SetText("DKP: No");
						EDBDKPText:SetTextColor(1,0.2,0.2);
					end
				else
					EDBDKPText:SetText("");
				end
			end
		else
			EDBDKPText:SetText(""); 
		end
	else
		EDBMSText:SetText("No entry");
		EDBOSText:SetText("for "..who);
	end
end

function EDB_Prune()
local safe=false;
	for i=1, GetNumGuildMembers(), 1 do 
		local name, rank = GetGuildRosterInfo(i);
		if(ELGOHDB[name] and ElgohIgnoreList[rank]) then
			if(ElgohDebug==1) then Elgoh_Print(name.." pruned from database (ignore rank list)"); end
			ELGOHDB[name]=nil
		end
	end
	for name,_ in pairs(ELGOHDB) do
		for i=1, GetNumGuildMembers(1), 1 do 
			local gname = GetGuildRosterInfo(i);
			if(gname==name) then safe=true; break; end
		end
		if(safe==false) then 
			if(ElgohDebug==1) then Elgoh_Print(name.." pruned from database (no longer in guild)"); end
			ELGOHDB[name]=nil; 
		end
		safe=false;
	end
end

function EDB_LoadValues()
	for i = 1, GetNumGuildMembers(), 1 do 
		local name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
		if(ELGOHDB[name]) then
			if(ELGOHDB[name]["current"]==nil) then
				ELGOHDB[name]["earned"]=0
				ELGOHDB[name]["spent"]=0
				ELGOHDB[name]["current"]=0
			end
			if(ELGOHDB[name]["current"] and GL_DKPValues["current_dkp_data"][name:lower()] and ELGOHDB[name]["current"]~=GL_DKPValues["current_dkp_data"][name:lower()]["current"]) then
				ELGOHDB[name]["earned"]=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				ELGOHDB[name]["spent"]=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				ELGOHDB[name]["current"]=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
				ELGOHDB[name]["updated"]=time();
				Elgoh_Print(name.."'s dkp has changed");
			end
		end
	end
end

function EDB_Sync()
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(ELGOHDB[name]) then
			if(ELGOHDB[name]["current"]==nil) then
				ELGOHDB[name]["earned"]=0
				ELGOHDB[name]["spent"]=0
				ELGOHDB[name]["current"]=0
			end
			local message=strjoin(":", name, ELGOHDB[name]["MS"], ELGOHDB[name]["OS"], ELGOHDB[name]["updated"], ELGOHDB[name]["earned"], ELGOHDB[name]["spent"], ELGOHDB[name]["current"])
			SendAddonMessage(ElgohDatabaseVersion,message, "GUILD");
		end
	end
end

function EDB_EDIT()
EditingName=GetGuildRosterInfo(GetGuildRosterSelection());
editmembername:SetText("Editing "..EditingName);
if(ELGOHDB[EditingName]) then
	EDBNewMS:SetText(ELGOHDB[EditingName]["MS"])
	EDBNewOS:SetText(ELGOHDB[EditingName]["OS"])
else
	EDBNewMS:SetText("No "..EditingName);
	EDBNewOS:SetText(":(");
end
	frmEDBADD:Show();
end

function EDB_Report(Short)
	local MSTanks=0;
	local MSHeals=0;
	local MSMelee=0;
	local MSRanged=0;
	local OSTanks=0;
	local OSHeals=0;
	local OSMelee=0;
	local OSRanged=0;
	local NID=0;

	for i = 1, GetNumGuildMembers(), 1 do 
	if(Short) then
		name, rank, rankIndex, level,_,_,_,_, online = GetGuildRosterInfo(i);
	else
		name, rank, rankIndex, level= GetGuildRosterInfo(i);
		online=1;
	end
		if(not ElgohIgnoreList[rank] and level==85 and online) then
			if(ELGOHDB[name]) then
				if(ELGOHDB[name]["MS"]=="Tank") then MSTanks=MSTanks+1; end
				if(ELGOHDB[name]["MS"]=="Healer") then MSHeals=MSHeals+1; end
				if(ELGOHDB[name]["MS"]=="Ranged DPS") then MSRanged=MSRanged+1; end
				if(ELGOHDB[name]["MS"]=="Melee DPS") then MSMelee=MSMelee+1; end
				
				if(ELGOHDB[name]["OS"]=="Tank") then OSTanks=OSTanks+1; end
				if(ELGOHDB[name]["OS"]=="Healer") then OSHeals=OSHeals+1; end
				if(ELGOHDB[name]["OS"]=="Ranged DPS") then OSRanged=OSRanged+1; end
				if(ELGOHDB[name]["OS"]=="Melee DPS") then OSMelee=OSMelee+1; end
			else
				NID=NID+1;
				if(ElgohDebug==1) then Elgoh_Print(name); end
			end
		end
	end
	if(Short==1) then
		Elgoh_Print("Online Spec Report:");
	else
		Elgoh_Print("Full Spec Report:");
		Elgoh_Print("("..NID.." characters weren't in the database)");
		Elgoh_Print(" ");
	end
	Elgoh_Print("Tanks: "..MSTanks);
	Elgoh_Print("Healers: "..MSHeals);
	if(MSRanged==1) then word="is"; else word="are"; end
	if(Short==1) then
		Elgoh_Print("DPS: "..(MSRanged+MSMelee).." ("..MSRanged.." "..word.." Ranged)")
	else
		Elgoh_Print("DPS: "..(MSRanged+MSMelee).." ["..MSRanged.." ("..string.format("%.0f",((MSRanged/(MSRanged+MSMelee))*100)).."%) "..word.." Ranged]")
		Elgoh_Print(" ");
		Elgoh_Print("Offspec Tanks: "..OSTanks);
		Elgoh_Print("Offspec Healers: "..OSHeals);
		Elgoh_Print("Offspec DPS: "..(OSRanged+OSMelee).." ["..MSRanged.." ("..string.format("%.0f",((OSRanged/(OSRanged+OSMelee))*100)).."%) "..word.." Ranged]")
	end
end

function EDB_Handle(self,button)
	if(button=="RightButton") then
		if(self:GetName()=="btnMSTank") then EDBNewOS:SetText("Tank"); end
		if(self:GetName()=="btnMSMelee") then EDBNewOS:SetText("Melee DPS"); end
		if(self:GetName()=="btnMSRanged") then EDBNewOS:SetText("Ranged DPS"); end
		if(self:GetName()=="btnMSHealer") then EDBNewOS:SetText("Healer"); end
	else
		if(self:GetName()=="btnMSTank") then EDBNewMS:SetText("Tank"); end
		if(self:GetName()=="btnMSMelee") then EDBNewMS:SetText("Melee DPS"); end
		if(self:GetName()=="btnMSRanged") then EDBNewMS:SetText("Ranged DPS"); end
		if(self:GetName()=="btnMSHealer") then EDBNewMS:SetText("Healer"); end
	end
end
